using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace FFXISwitchMon
{
   //Application Callback Prototypes
   public delegate void genericevent();
   public delegate void windowchanged(IntPtr hWnd);
   public delegate void windowevent(FFXIWindow window);

   //Global Classes & Enums
   public class FFXIWindow {
      public IntPtr hwnd;
      public string classname;
      public bool   dirty;
      public bool   unallowactivate;
   }

   public enum ActionCommand {
      ActivateNext = 0,
      ActivatePrev = 1,
      ToggleZoom = 2,
      ToggleMagnifiers = 3,
      CycleSets = 4,
      OpenMenu = 5,
   } 
   
   static class Program {
      public static Dictionary<ActionCommand, string> ActionDescription;
      public static Dictionary<ActionCommand, string> DefaultMenuTitles;
   
      /// <summary>
      /// The main entry point for the application.
      /// </summary>
      [STAThread]
      static void Main() {
		//2018-8-31ǉ-------------------------------------------------------------------------------------------------------
			//Mutex߂
			string mutexName = "FFXISwitchMon";
			//MutexIuWFNg쐬
			bool createdNew;
			System.Threading.Mutex mutex = new System.Threading.Mutex(true, mutexName, out createdNew);

			//~[ebNX̏Lt^ꂽׂ
			if (createdNew == false)
			{
				//Ȃꍇ́AłɋNĂƔfďI
				MessageBox.Show("FFXISwitchMon is already running.","Message",MessageBoxButtons.OK,MessageBoxIcon.Error);
				mutex.Close();
				return;
			}

			try
			{
				Application.EnableVisualStyles();
				Application.SetCompatibleTextRenderingDefault(false);

				//Global settings
				ActionDescription = new Dictionary<ActionCommand, string>();
				ActionDescription[ActionCommand.ActivateNext] = "Switch Next";
				ActionDescription[ActionCommand.ActivatePrev] = "Switch Previous";
				ActionDescription[ActionCommand.ToggleZoom] = "Toggle Maximize/Normal";
				ActionDescription[ActionCommand.ToggleMagnifiers] = "Toggle Magnifiers";
				ActionDescription[ActionCommand.CycleSets] = "Cycle Magnifier Set";
				ActionDescription[ActionCommand.OpenMenu] = "Toggle Menu";

				DefaultMenuTitles = new Dictionary<ActionCommand, string>();
				DefaultMenuTitles[ActionCommand.ActivateNext] = "Next";
				DefaultMenuTitles[ActionCommand.ActivatePrev] = "Previous";
				DefaultMenuTitles[ActionCommand.ToggleZoom] = "Zoom";
				DefaultMenuTitles[ActionCommand.ToggleMagnifiers] = "%magstate%\n%curset%";
				DefaultMenuTitles[ActionCommand.CycleSets] = "Next:\n%nextset%";

				//Debug Warnings
				#if DEBUG
						 System.Diagnostics.Trace.WriteLine("----------------------------\nDebug Mode Enabled.\n----------------------------");   
				#if FAKEWND
				#warning "Fake window generation enabled"
						 System.Diagnostics.Trace.WriteLine("WARNING: Fake game window generation ENABLED!");
				#endif
				#endif

				//This is a windowless app, so only create the form object and start a generic pump
				fMonitor app = new fMonitor();
				Application.Run();
			}
			finally
			{
				//~[ebNX
				mutex.ReleaseMutex();
				mutex.Close();
			}
		//------------------------------------------------------------------------------------------------------------------
        
      }
   }
}